#include "BLReader.hpp"

bool BLReader::ReadNextCandidate(HeadRecord& x) {
	if (m_startRead == false) {
		m_fileH = std::ifstream(m_fileName);
		if (!m_fileH.good()) {
			throw std::exception("The specified nbest file was not found");
			exit(-1);	
		}
		m_startRead = true;
	}

	std::string line = "";
	
	if (!std::getline(m_fileH, line))
		return false;
	
	std::istringstream tabTokenizer(line);
	std::string segment;
	
	int part = 0;

	x = HeadRecord();

	while (std::getline(tabTokenizer, segment, '\t')) { 
		if (part == 0) {
			// Head record split on ':'
			size_t cidPos = segment.find(":", 0);			
			x.cid = segment.substr(0, cidPos);
			x.ctext = segment.substr(cidPos+1, segment.size());
		} else if (part == 1) {
			// Head record split on ':'
			size_t midPos = segment.find(':', 0);			
			x.mid = segment.substr(0, midPos);
			x.mtext = segment.substr(midPos+1);
		} else {
			// Tail Records
			TailRecord t; 
			
			size_t ridScore = segment.find_first_of(':', 0);
			t.featureValues.push_back(std::atof(segment.substr(0, ridScore).c_str()));
			size_t ridPos = segment.find_first_of(':', ridScore+1);
			t.rid = segment.substr(ridScore+1, ridPos-ridScore-2);
			t.rtext = segment.substr(ridPos+1);
			x.rlist.push_back(t);
		}

		part++;
	}
	
	return true;
}