#pragma once

#include "DcgmII.hpp"

class DcgmIII : public DcgmII {
public:
	DcgmIII() : DcgmII() {
		m_modelName = "DCGM-III";
	}
	
	DcgmIII(int nHid, int nOut) : DcgmII(nHid, nOut) {
		m_modelName = "DCGM-III";
	}
	
	DcgmIII(bool proprietaryMemory) : DcgmII(proprietaryMemory) {
		m_modelName = "DCGM-III";
	}

	~DcgmIII() {
		if (m_proprietaryMemory)
			DeleteWeights();
	}

public:
	/// public loader for this model
	static DcgmIII* LoadFromDisk(const std::string& dirPath);

protected:
	virtual void AddStep(const Sequence& s, size_t step, NeuralNet& rnn, Layer*& ctxLayer, Layer*& lastHiddenLayer, bool training=true);
};