#pragma once

#include "DcgmII.hpp"

class DcgmIV : public DcgmII {
public:
	DcgmIV() : DcgmII() {
		m_modelName = "DCGM-IV";
	}
	
	DcgmIV(int nHid, int nOut) : DcgmII(nHid, nOut) {
		m_modelName = "DCGM-IV";
	}
	
	DcgmIV(bool proprietaryMemory) : DcgmII(proprietaryMemory) {
		m_modelName = "DCGM-IV";
	}

	~DcgmIV() {
		if (m_proprietaryMemory)
			DeleteWeights();
	}

public:
	/// public loader for this model
	static DcgmIV* LoadFromDisk(const std::string& dirPath);

protected:
	virtual Layer* BuildContext(const Triple& cmr, NeuralNet& network);
	virtual void AddStep(const Sequence& s, size_t step, NeuralNet& rnn, Layer*& ctxLayer, Layer*& lastHiddenLayer, bool training=true);
};