#pragma once

#include "Rnn.hpp"
#include "Fcgm.hpp"
#include "DcgmI.hpp"
#include "DcgmII.hpp"
#include "DcgmIII.hpp"
#include "DcgmIV.hpp"

#include "AbstractModel.hpp"

class ModelLoader
{
public:
	static AbstractModel* LoadFromDisk(const std::string dirPath) 
	{
		std::ifstream f(dirPath + "\\modelType");
		if (!f.good())
		{
			throw std::exception("Corrupted model directory!");
		}
		
		std::cerr << "Loading Model..." << std::endl;
		std::string modelType = "";
		f >> modelType;
		f.close();
		
		std::cout << "- Detected " << modelType << std::endl;
		
		AbstractModel* m = nullptr;
		if (modelType == "DCGM-I")
			m = DcgmI::LoadFromDisk(dirPath);
		else if (modelType == "DCGM-II")
			m = DcgmII::LoadFromDisk(dirPath);
		else if (modelType == "DCGM-III")
			m = DcgmIII::LoadFromDisk(dirPath);
		else if (modelType == "DCGM-IV")
			m = DcgmIV::LoadFromDisk(dirPath);
		else if (modelType == "FCGM")			
			m = Fcgm::LoadFromDisk(dirPath);
		else if (modelType == "RNN")
			m = Rnn::LoadFromDisk(dirPath);
		return m;
	}
};