#pragma once

#include "Fcgm.hpp"

class Rcgm : public Fcgm 
{
	Matrix* m_Wshh;
	Matrix* m_Wsin;
	Matrix* m_bshh;

	std::vector<NCELossLayer*> m_nceLayers;
	std::vector<CrossEntropyLossLayer*> m_ceLayers;

private:
	Layer* BuildRnn(Layer* contextLayer, std::string seqName, const Sequence& seq, NeuralNet& network);
	void BuildNetwork(const Triple& triple, NeuralNet& network);
	void SetIO(const Triple& seq);

public:
	Rcgm() : Fcgm() {}
	Rcgm(int nHid, int nOut) : Fcgm(nHid, nOut) {}
	~Rcgm() {
		if (m_proprietaryMemory)
		{
			delete m_Wshh; delete m_Wsin; 
		}
	}

	void SetSentenceRnnWeights(Matrix* WShh, Matrix* WSin, Matrix* bshh) {
		m_Wsin = WSin;
		m_Wshh = WShh;
		m_bshh = bshh;
	}

	static Rcgm* LoadFromFile(const std::string& dirPath);
	
	double Test(const Triple& tri, bool stoch=false);
	double Train(const Triple& seq);
	std::vector<int> Generate(const Triple& cmr);
};