#include "TripleReader.hpp"

bool TripleReader::ReadNextBatch() {
	std::string line;
	int batchSize = 0;
	bool stillRead = false;
	Batch<Triple> wi;

	while (std::getline(readerStream, line)) {
		Triple t; t.reserve(3);

		// Parse sequences
		std::istringstream ss(line);
		std::string sequence;

		while (std::getline(ss, sequence, '\t')) {
			// Tokenize it
			std::stringstream tokenizer(sequence);
			
			Sequence seq;
			std::string tok;
			while (tokenizer >> tok) 
				seq.push_back(std::atoi(tok.c_str()));
			
			if (seq.size() > 0) {
				t.push_back(seq);
			}
		}
		
		if (t.size() != 3) {
			// Do not load this triple but we do it silently..
			// never do errors!
			continue;
		}

		wi.data.push_back(t);
		wi.m_size = ++batchSize;

		if (batchSize >= m_mbSize) {
			m_read += m_mbSize;
			stillRead = true;
			break;
		}
	}

	// Shuffle
	if (batchSize != 0) {
		std::shuffle(wi.data.begin(), wi.data.end(), rd);
		m_queue->Push(wi);
	}
	
	return stillRead;
}