//
//  visitor.hpp
//  Nnet
//
//  Created by Alessandro Sordoni on 2014-04-21.
//  Copyright (c) 2014 Alessandro Sordoni. All rights reserved.
//

#ifndef Nnet_visitor_hpp
#define Nnet_visitor_hpp

class Visitor {
protected:
	bool m_visitEdges;
	bool m_visitNodes;

public:
	Visitor();
	
	bool IsVisitEdges() const { return m_visitEdges; }
	bool IsVisitNodes() const { return m_visitNodes; }

    void defaultVisit(class Node* node);
    void defaultVisit(class Link* link);

	virtual void pre_visit();
	virtual void post_visit();
    
    virtual void Visit(class DynamicWeight* w);
    virtual void Visit(class FixedWeight* w);
    virtual void Visit(class DenseLayer* w);
    virtual void Visit(class HiddenLayer* w);
    virtual void Visit(class SparseInputLayer* w);
    virtual void Visit(class DenseInputLayer* w);
    virtual void Visit(class CrossEntropyLossLayer* w);
	virtual void Visit(class ConstantLossLayer* w);
    virtual void Visit(class L2LossLayer* w);
	virtual void Visit(class NCELossLayer* w);
};

#endif
