#pragma once

#include "DataStructures.hpp"
#include <string>
#include <vector>
#include <fstream>

class AbstractWriter { 

protected:
	std::ofstream m_outputWriter;

public:
	AbstractWriter(std::string outputFile) {
		m_outputWriter = std::ofstream(outputFile);
		if (!m_outputWriter.good()) {
			throw std::exception("Found error in opening output file!");
		}
	}

	virtual void WriteRecord(const HeadRecord& x) = 0;
	virtual ~AbstractWriter() {
		m_outputWriter.close();
	}
};