#pragma once

#include "AbstractWriter.hpp"

class BLWriter : public AbstractWriter {
public:
	BLWriter(std::string outputFile) : AbstractWriter(outputFile) {}
		
	void WriteRecord(const HeadRecord& x) {
		m_outputWriter << x.cid << ":" << x.ctext << "\t" << x.mid << ":" << x.mtext << "\t";
		for (int i = 0; i < x.rlist.size(); i++) {
			m_outputWriter << x.rlist[i].score << ":" << x.rlist[i].rid << ":" << x.rlist[i].rtext;
			if (i != x.rlist.size()-1)
				m_outputWriter << "\t";
		}

		m_outputWriter << std::endl;
	}

	~BLWriter() {
		m_outputWriter.close();
	}
};
