#pragma once

#include "DataStructures.hpp"
#include "AbstractReader.hpp"

#define BUNCH_SIZE 100

class SequenceBatchedReader : public AbstractReader<Batch<Sequence>> {
private:
	std::vector<int> lengths;

public:
	SequenceBatchedReader() : AbstractReader() {
		for (int i = 0; i < 100; i++)
			lengths.push_back(i);
	};

	SequenceBatchedReader(ThreadedQueue<Batch<Sequence>>* t) : AbstractReader(t) {}
	bool ReadNextBatch();
};

class TripleBatchedReader : public AbstractReader<Batch<Triple>> {
private:
	std::vector<Triple> m_buf;
	std::vector<int> lengths;

public:
	TripleBatchedReader() : AbstractReader() {
		for (int i = 0; i < 100; i++)
			lengths.push_back(i);
	};
	TripleBatchedReader(ThreadedQueue<Batch<Triple>>* t) : AbstractReader(t) {}
	bool ReadNextBatch();
};