#include "SequenceReader.hpp"

bool SequenceReader::ReadNextBatch() {
	std::string line;
	int batchSize = 0;
	bool stillRead = false;
	Batch<Sequence> wi;

	while (std::getline(readerStream, line)) {
		Sequence seq;
		std::stringstream ss(line);
		std::string tok;
		
		while (ss >> tok) 
			seq.push_back(std::atoi(tok.c_str()));

		if (seq.size() > 0) {
			wi.data.push_back(seq);
			wi.m_size = ++batchSize;
		}

		if (batchSize >= m_mbSize) {
			m_read += m_mbSize;
			stillRead = true;
			break;
		}
	}

	// Shuffle
	if (batchSize != 0) {
		std::shuffle(wi.data.begin(), wi.data.end(), rd);
		m_queue->Push(wi);
	}
	
	return stillRead;
}