# Given a tgt file - append the b4stats 
#
# @author Alessandro Sordoni

import sys
import tgt_reader
import ir_reader
import bleu4

if len(sys.argv) < 1:
	print "USAGE: TGT"
	sys.exit(-1)

### Load Tgt Records
tgt = tgt_reader.TgtReader(sys.argv[1])
records = tgt.GetRecords()

outputFile = sys.argv[1]
pos = sys.argv[1].find(".tgt")
if pos != -1:
	outputFile = outputFile[:pos]
outputFile = outputFile + ".b4.tgt"

tgtWriter = tgt_reader.TgtWriter(outputFile)
for record in records:
	record.featureNames = record.featureNames + ["1-gramcount","1-grammatch","2-gramcount","2-grammatch","3-gramcount","3-grammatch","4-gramcount","4-grammatch","reflen"]
	
	# Multireferences
	refSuffStats = bleu4.SuffStats(record.rtext)
	
	for hyp in record.rlist:
		b = bleu4.Bleu4()
		# Candidate
		candSuffStats = bleu4.SuffStats(hyp.rtext)
		b.UpdateNgramMultiRefStatsFromSuffStats(refSuffStats, candSuffStats)
		rMatches = [b.Get1GramCount(), b.Get1GramMatch(), b.Get2GramCount(), b.Get2GramMatch(), b.Get3GramCount(), b.Get3GramMatch(), b.Get4GramCount(), b.Get4GramMatch(), b.GetRefLen()]
		b.ResetStats()
	
		hyp.featureValues = hyp.featureValues + rMatches

tgtWriter.WriteRecords(records)