# Given a tgt file - append the cmmatches 
#
# @author Alessandro Sordoni

import sys
import tgt_reader
import ir_reader
import bleu4

if len(sys.argv) < 1:
	print "USAGE: TGT"
	sys.exit(-1)

### Load Tgt Records
tgt = tgt_reader.TgtReader(sys.argv[1])
records = tgt.GetRecords()

outputFile = sys.argv[1]
pos = sys.argv[1].find(".tgt")
if pos != -1:
	outputFile = outputFile[:pos]
outputFile = outputFile + ".cmmatch.tgt"

tgtWriter = tgt_reader.TgtWriter(outputFile)
for record in records:
	record.featureNames = ["c-1-grammatch","c-2-grammatch","c-3-grammatch","c-4-grammatch","m-1-grammatch","m-2-grammatch","m-3-grammatch","m-4-grammatch"] + record.featureNames
	
	if len(record.ctext) == 0:
		print "Not a \CTX enriched TGT!"
		sys.exit(-1)
	
	cSuffStats = bleu4.SuffStats([record.ctext])
	mSuffStats = bleu4.SuffStats([record.mtext])
	
	for hyp in record.rlist:
		candSuffStats = bleu4.SuffStats([hyp.rtext])
		
		b = bleu4.Bleu4()
		b.UpdateNgramMultiRefStatsFromSuffStats(cSuffStats, candSuffStats)
		cMatches = [b.Get1GramMatch(),b.Get2GramMatch(),b.Get3GramMatch(),b.Get4GramMatch()]
		b.ResetStats()
	
		b.UpdateNgramMultiRefStatsFromSuffStats(mSuffStats, candSuffStats)
		mMatches = [b.Get1GramMatch(),b.Get2GramMatch(),b.Get3GramMatch(),b.Get4GramMatch()]
		b.ResetStats()
		
		hyp.featureValues = cMatches + mMatches + hyp.featureValues

tgtWriter.WriteRecords(records)