## Name: extractPairs.py
## Purpose: extract sentence (status/reponse) pairs from smoke.tgt file
## Author: Yangfeng Ji 
## Date: 06-06-2014
## Time-stamp: <>

def extract(fname_in, fname_pairs, fname_all):
    fout = open(fname_pairs, 'w')
    fout_all = open(fname_all, 'w')
    is_status = True
    is_response = False
    with open(fname_in, 'r') as fin:
        for line in fin:
            line = line.strip()
            # print line
            if is_status:
                curr_status = line
                is_status = False
            if len(line) == 0:
                is_status = True
                is_response = False
            if 'REF' in line:
                curr_ref = line
            if '@@H' in line:
                curr_head = line
            if '@@Q' in line:
                is_response = True
            if ('@@' not in line) and (not is_status) and (is_response):
                response = line
            if ('@@V' in line):
                # print 'Write file ...'
                score = line
                # Response \t Status
                fout.write(response + '\t' + curr_status + '\r\n')
                fout_all.write(curr_status + '\t' + curr_ref + '\t' + response + '\t' + curr_head + '\t' + score + '\r\n')
    print 'Done'

if __name__ == '__main__':
    import sys
    if len(sys.argv) != 4:
        print 'Arguments error for extractPairs.py'
    else:
        # fname_in = './TestData/smoke-utf8.tgt'
        # fname_pairs = './TestData/twitter.test.pairs'
        # fname_all = './TestData/twitter.test.all'
        fname_in = sys.argv[1]
        fname_pairs = sys.argv[2]
        fname_all = sys.argv[3]
        print 'read file from {}\n write into file {} and {}'.format(fname_in, fname_pairs, fname_all)
        extract(fname_in, fname_pairs, fname_all)
