### Convert a file to IDS + UNK
import operator
import sys
if len(sys.argv) < 2:
	print "USAGE: CUTOFF INPUT_DATA_PATH OUTPUT_DATA_PATH "
	sys.exit(0)

if int(sys.argv[1]) == 0:
	print "Do not need to filter!"
	sys.exit(0)
	
input_data = sys.argv[2]
output_data = input_data
if len(sys.argv) > 3:
	output_data = str(sys.argv[3])

dir_vocabulary = []
inv_vocabulary = {}

id = 0
lines = 0
input_file = open(input_data, "r")
for line in input_file:
	lines += 1
	if lines % 100000 == 0:
		print "Read ", lines
	for token in line.split():
		token = token.strip()
		if len(token) == 0:
			continue
		if token in inv_vocabulary:
			inv_vocabulary[token] += 1
		else:
			inv_vocabulary[token] = 1			
input_file.close()

print " Read sentences = " , lines
print " Size of the vocabulary = " , len(inv_vocabulary)

## Sort
sorted_inv = sorted(inv_vocabulary.items(), key=operator.itemgetter(1), reverse=True)
print " First token is = ", sorted_inv[0]

cutoff = int(sys.argv[1])
if cutoff == 0:
	cutoff = len(sorted_inv)
	
sorted_inv = sorted_inv[:cutoff]
cutoff_dict = dict(sorted_inv)
print " Size after cutoff = ", len(cutoff_dict)
print cutoff_dict

print " Writing output "
ow = open(output_data + ".%dK" % int(cutoff/1000), "w")
input_file = open(input_data, "r")
for line in input_file:		
	to_write = []
	sentences = line.split("\t");	
	
	line_to_write = []
	for sentence in sentences:
		sentence_to_write = []
		### Start string
		for token in sentence.split(" "):
			token = token.strip()
			if len(token) == 0:
				continue
			if token in cutoff_dict:
				sentence_to_write.append(token)
			else:
				sentence_to_write.append("<unk>")	
		line_to_write.append(" ".join(sentence_to_write))
	
	#### Here we conserve the structure of tab separated values!	
	print >> ow, '\t'.join(line_to_write)
input_file.close()
ow.close()
print " Done "
