### Convert a file to IDS + UNK
import operator
import sys
import re

if len(sys.argv) < 3:
	print "USAGE: DICT_PATH FILE_PATH"
	sys.exit(0)
	
input_data = sys.argv[2]
input_dict = sys.argv[1]
output_data = input_data

id_vocabulary = {}

## Load vocabulary
id = 0
for line in open(input_dict, "r"):
	token, count, _ = line.strip().split(" ")
	id_vocabulary[token] = str(id)
	id += 1

p = re.compile('[^a-zA-Z!\-? ]+') 
lines = 0
unknowns = 0
total_terms = 0
ow = open(output_data + ".folded", "w")

for line in open(input_data, "r"):
	to_write = []
	sentences = line.split("\t");
	
	lines += 1
	if lines % 100000 == 0:
		print "Converted ", lines
		
	line_to_write = []
	for sentence in sentences:
		sentence_to_write = []
		
		### Start string
		for token in sentence.split(" "):
			token = token.strip()
			if len(token) == 0:
				continue
			if token in id_vocabulary:
				sentence_to_write.append(id_vocabulary[token])
			else:
				unknowns += 1
				sentence_to_write.append(id_vocabulary["<unk>"])
			total_terms += 1
		line_to_write.append(" ".join(sentence_to_write))
	#### Here we conserve the structure of tab separated values!	
	print >> ow, '\t'.join(line_to_write)

print " Total terms = %d" % total_terms
print " % of unknowns = ", str(float(unknowns)/float(total_terms))
ow.close()

