import sys
import io
import collections
import operator

class HeadRecord:
	def __init__(self):
		self.cid = ""
		self.ctext = ""
		self.mid = ""
		self.featureNames = []
		self.mtext = ""
		self.rtext = [] 	### List of multireferences
		self.rid = []		### List of multireferences ids (just 0 for tgt files)
		self.rlist = [] 	### List of candidate translations i.e. generated Rs

class TailRecord:
	def __init__(self):
		self.rid = ""
		self.score = 0
		self.rtext = ""

class IRReader:
	def __init__(self, file):
		reader = open(file, "r")
		self.lines = reader.readlines()
		reader.close()
		
		self.currNumLine = 0
		self.numLines = len(self.lines)
		self.linesRead = []
		self.currId = ""
		
	def GetRecords(self, keepOriginals=False):
		d = []
		
		print "IR READER ===================="
		
		for line in self.lines:
			line = line.strip()
			if len(line) == 0:
				continue
			
			values = line.split("\t")
			cpart = values[0].find(":")
			mpart = values[1].find(":")
			
			currentMrHead = HeadRecord()
			currentMrHead.cid = values[0][:cpart]
			currentMrHead.ctext = values[0][cpart+1:]
			currentMrHead.mid = values[1][:mpart]
			currentMrHead.mtext = values[1][mpart+1:]
			
			currentMrTails = []
			for tail in values[2:]:
				cscore = tail.find(":")
				cid = tail.find(":", cscore+1)
				currentMrTail = TailRecord()
				currentMrTail.rid = tail[cscore+1:cid]
				currentMrTail.rtext = tail[cid+1:]
				currentMrTail.score = float(tail[:cscore])
				currentMrTails.append(currentMrTail)
			
			currentMrHead.rlist = currentMrTails
			d.append(currentMrHead)
		
		for v in d:
			v.rlist.sort(key=lambda tup : tup.score, reverse=True)
		
		
		print "Loaded records = %d" % len(d)
		print "===================="
		
		return d