# Lambda reader
#
# @author Alessandro Sordoni.

import codecs
import sys

class LambdaRecord:
	def __init__(self):
		self.lambdas = []
		self.featureNames = []

class LambdaReader:
	def __init__(self, file):
		self.file = file
		self.includeFeatureValues = False
		self.currNumLine = 0
		self.numLines = 0
		self.linesRead = []
		self.currId = ""
		
	def GetRecords(self):
		f = codecs.open(self.file,'r', encoding='utf-16')
		lines = ""
		try:
			### utf-16 encoding
			lines = f.read()
		except UnicodeError:
			f.close()
			lines = open(self.file, "r").read()
		f.close()
		
		print "LAMBDA READER ================="
		## Filter out commentaries
		lambdaLines = [x.strip() for x in lines.split("\n") if x.find("//") == -1 and len(x) > 1]
		lambdaRecord = LambdaRecord()
		
		for line in lambdaLines:
			records = line.split()
			if len(records) != 4:
				print >> sys.stderr , "Unrecognized lambda file!"
				sys.exit(-1)
			
			lambdaRecord.featureNames.append(records[2])
			lambdaRecord.lambdas.append(float(records[3]))
		
		print "\n".join(["{:>15} = {:<5}".format(x, z) for x, z in zip(lambdaRecord.featureNames, lambdaRecord.lambdas)])
		print "================="
		return lambdaRecord
