# Merges a "feature" file to a TGT
# ------------------------------
# Feature file is in the format
# Feature Name
# score
# score
# ...
# @author Alessandro Sordoni

import sys
import tgt_reader
import os

if len(sys.argv) < 3:
	print "Not enough arguments! [TGT] [FEATURE FILE]"
	sys.exit(-1)
	
r = tgt_reader.TgtReader(sys.argv[1])
records = r.GetRecords()

f = open(sys.argv[2], "r").readlines()
featureName = f[0].strip()

output = sys.argv[2] + ".tgt"
if len(sys.argv) == 4:
	output = sys.argv[3]

print "====================================="
print "Detected feature ", featureName 
print "Output file ", output
print "====================================="

w = tgt_reader.TgtWriter(output)
done = 1
for r in records:
	r.featureNames = [featureName] + r.featureNames
	for x in r.rlist:
		x.featureValues = [str(f[done].strip())] + x.featureValues
		done += 1
w.WriteRecords(records)