## Name: mergeSim.py
## Purpose: merge similarity score from DSSM into *.tgt file
## Author: Yangfeng Ji 
## Date: 06-06-2014

idx=6

def changeTitle(title):
    items = title.split(',')
    items.insert(idx, 'ChannelModel6')
    # items.insert(idx+1, 'ChannelModel7')
    title = ','.join(items)
    return title

def addValue(values, score1):
    items = values.split(',')
    items.insert(idx, str(score1))
    # items.insert(idx+1, str(score2))
    values = ','.join(items)
    return values

def merge(fname_all, fname_ent, fname_out):
    fsim = open(fname_ent, 'r')
    fout = open(fname_out, 'w')
    is_new = False
    curr_status = ''
    curr_best = ''
    counter = 0
    with open(fname_all, 'r') as fin:
        for line in fin:
            score = float(fsim.readline().strip())
            # rscore = float(frsim.readline().strip())
            items = line.strip().split('\t')
            status = items[0]
            ref = items[1]
            response = items[2]
            title = items[3]
            values = items[4]
            prev_best = ''
            if status != curr_status:
                is_new = True
                counter += 1
                curr_status = status
                prev_best = curr_best
                curr_best = response
            # if is_new == True, write status and title and something else
            if is_new:
                if counter > 1:
                    fout.write('@@===\n')
                    fout.write('  -+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-\n')
                    fout.write(prev_best + '\n')
                    fout.write('generate2()\n')
                    fout.write('====================================================\n')
                    fout.write('\n')
                fout.write(status + '\n')
                fout.write(ref + '\n')
                title = changeTitle(title)
                fout.write(title + '\n')
                fout.write('@@Q\n')
                is_new = False
            fout.write(response + '\n')
            values = addValue(values,score)
            fout.write(values + '\n')
                           

if __name__ == '__main__':
    import sys
    if len(sys.argv) != 4:
        print "Usage: python mergeMaxent.py [filename].all [fileent] [fnameout]"
    else:
        fname_all = sys.argv[1]
        fname_ent = sys.argv[2]
        fname_out = sys.argv[3]
        merge(fname_all, fname_ent, fname_out)
