# Take the hypothesis of the first 
# tgt and inserts as candidates in the other TGT
#
# @author Alessandro Sordoni

import tgt_reader
import sys

if len(sys.argv) != 4:
	print >> sys.stderr, "Specify 2 tgts and 1 output file, not enough arguments."
	sys.exit(-1)

a = tgt_reader.TgtReader(sys.argv[1])
b = tgt_reader.TgtReader(sys.argv[2])
c = tgt_reader.TgtWriter(sys.argv[3])

ar = a.GetRecords()
br = b.GetRecords()

if len(ar) != len(br):
	print >> sys.stderr, "Record lengths mismatch!"
	sys.exit(-1)

for idx, r in enumerate(ar):
	### Build the b dict
	refDict = {}
	for index, object in enumerate(br[idx].rlist):
		refDict[object.rtext] = index
	
	for y in r.rlist:
		if y.rtext not in refDict:
			br[idx].rlist.append(y)
		else:
			# Update the feature values
			index = refDict[y.rtext]
			br[idx].rlist[index].featureValues = y.featureValues
	
c.WriteRecords(br)