import sys
import io
import collections
import operator

class HeadRecord:
	def __init__(self):
		self.cid = ""
		self.ctext = ""
		self.mid = ""
		self.mtext = ""
		self.rtext = ""
		self.rid = ""
		self.rlist = []
		
class TailRecord:
	def __init__(self):
		self.rtext = ""
		self.score = ""
		self.rid = ""

class MultiRefReader:
	def __init__(self, file):
		reader = open(file, "r")
		self.lines = reader.readlines()
		reader.close()
		
		self.currNumLine = 0
		self.numLines = len(self.lines)
		self.linesRead = []
		self.currId = ""
		
	def GetRecords(self):
		d = collections.OrderedDict()
		
		for line in self.lines:
			values = line.strip().split("\t")
			original = values[7]
			
			currentMrHead = HeadRecord()
			currentMrHead.cid = values[1]
			currentMrHead.ctext = values[4]
			currentMrHead.mid = values[2]
			currentMrHead.mtext = values[5]
			
			#### Skip this if it is an original
			if original == "original":
				if currentMrHead.mid in d:
					d[currentMrHead.mid].rid = values[3]
					d[currentMrHead.mid].rtext = values[6]
				else:
					currentMrHead.rid = values[3]
					currentMrHead.rtext = values[6]
					d[currentMrHead.mid] = currentMrHead
				continue
			else:
				currentMrTail = TailRecord()
				currentMrTail.rid = values[3]
				currentMrTail.rtext = values[6]
				currentMrTail.score = float(values[8])
			
			if currentMrHead.mid in d:
				d[currentMrHead.mid].rlist.append(currentMrTail)
			else:
				currentMrHead.rlist.append(currentMrTail)
				d[currentMrHead.mid] = currentMrHead
		
		for k, v in d.items():
			v.rlist.sort(key=lambda tup : tup.score, reverse=False)
		
		return d