import numpy as np
import sys
from bleu4 import Bleu4

class PermutationTest():
	def __init__(self, b4stats1, b4stats2):
		self.b4stats1 = b4stats1
		self.b4stats2 = b4stats2
	
	def GetPValue(self, numPermutations):
		fb = Bleu4()
		sb = Bleu4()
		
		fb.statistics = self.b4stats1
		sb.statistics = self.b4stats2
		
		shfB = fb.GetCorpusB4()
		shsB = sb.GetCorpusB4()
		trueDifference = np.abs(shfB-shsB)
		
		numRecords = len(fb.statistics)
		positiveCounts = 0
		
		for i in range(numPermutations):
			sys.stdout.write("\r%d" % i)
			sys.stdout.flush()
	
			mask = np.random.randint(2, size=numRecords)
			
			### Apply mask (swap counts)
			for i in range(numRecords):
				if mask[i] == 1:
					tmp = self.b4stats1[i]
					self.b4stats1[i] = self.b4stats2[i]
					self.b4stats2[i] = tmp
			
			fb.statistics = self.b4stats1
			sb.statistics = self.b4stats2
			
			shfB = fb.GetB4()
			shsB = sb.GetB4()
	
			sample = np.abs(shfB - shsB)
			if sample >= trueDifference:
				positiveCounts += 1
	
			### Reestablish true counts (reswap)
			for i in range(numRecords):
				if mask[i] == 1:
					tmp = self.b4stats2[i]
					self.b4stats2[i] = self.b4stats1[i]
					self.b4stats1[i] = tmp
		
		return float(float(positiveCounts+1)/float(numPermutations+1))

#p = PermutationTest([[1,1,1,1,1,1,1,1,1],[2,2,2,2,2,2,2,2,2]],[[3,3,3,3,3,3,3,3,3],[4,4,4,4,4,4,4,4,4]])
#p.GetPValue(10)