## Estimate the parameters of a conditional poisson distribution
## on lengths from a tabbed separated file.
##
## @author Alessandro Sordoni

import sys
import numpy
from collections import defaultdict

if len(sys.argv) <= 1:
	print "Specify an input dataset"
	sys.exit(-1);
	
f = open(sys.argv[1], "r")

jointCounts = defaultdict(int)
sourceCounts = defaultdict(int)
targetCounts = defaultdict(int)

maxSourceLength = 0
meanTargetLength = 0
numTargets = 0

count = 0
for line in f:
	values = line.split("\t")
	if len(values) == 3:
		count += 1
	else:
		continue
	
	target = values[-1]
	source = " ".join(values[:-1])
	
	targetLen = len(target.split(" "))
	sourceLen = len(source.split(" "))
	
	jointCounts[sourceLen] += targetLen
	sourceCounts[sourceLen] += 1
	targetCounts[targetLen] += 1
	
	maxSourceLength = max(sourceLen, maxSourceLength)
	meanTargetLength += targetLen
	numTargets += 1

meanTargetLength = float(meanTargetLength)/float(numTargets)
poissonParameters = defaultdict(int)

for key, value in sourceCounts.items():
	lambdaPoisson = float(jointCounts[key])/float(value)
	poissonParameters[key] = lambdaPoisson

print "Done sentences ", count
	
#### Default poisson lambda
o = open("poisson.lambdas", "w")
print >> o, 0, meanTargetLength
for key, value in poissonParameters.items():
	print >> o, key, value