## Given a scoring rich prod format
## and a dev.multiref format
## produces a file with C \t M \t R \t score

import sys
import multiref_reader

r = multiref_reader.MultiRefReader(sys.argv[1])
outputFile = open(sys.argv[1] + ".prels", "w")

gaoFormat = False
ourFormat = False
if sys.argv[2] == "GAO":
	gaoFormat = True
else:
	ourFormat = True
	
to_store = []
to_write = []
keyId = 0

records = r.GetRecords()
for mid, head in records.items():
	recordToWrite = []
	lineToWrite = []
	if gaoFormat:
		for tail in head.rlist:
			lineToWrite = []
			lineToWrite.append(head.cid)
			lineToWrite.append(head.ctext)   ### ctext
			lineToWrite.append(head.mtext)   ### mtext
			lineToWrite.append(tail.rtext)   ### rtext
			lineToWrite.append(tail.score)   ### score
			recordToWrite.append("\t".join(lineToWrite))
	else:
		#if len(head.rlist) == 0:
		#	continue
		
		lineToWrite.append(":".join([head.cid, head.ctext])) ### cid:ctext
		lineToWrite.append(":".join([head.mid, head.mtext]))  ### mid:mtext
		lineToWrite.append(":".join([str(1), head.rid, head.rtext]))  ### original answer rid:rtext
		for tail in head.rlist:
			lineToWrite.append(":".join([str(tail.score),tail.rid,tail.rtext]))
		recordToWrite.append("\t".join(lineToWrite))
	print >> outputFile, "\n".join(recordToWrite)
outputFile.close()