# Computes a rank-sensitive B4
# The tgt file is important in order to get the multireferences in order 
# to compute bleu4 statistics
#
# @author Alessandro Sordoni

from bleu4 import Bleu4
import sys
import collections
import random
from permutation_test import PermutationTest
import numpy
import numpy as np
import copy
from random import randint

from tgt_reader import *
if len(sys.argv) < 3:
	print "Please specify a tgt file and one or more tsv candidate lists"
	sys.exit(-1)

numSystems = len(sys.argv[2:])
rankedSystems = []
rankedSystemsScores = []

for i in range(numSystems):
	print >> sys.stderr, "Loading candidate list : %s" % sys.argv[2+i]
	lines = open(sys.argv[2+i], "r").readlines()
	lines = [x.strip().split("\t") for x in lines if len(x) != 0]
	
	### Here one should ensure that .scores file are in the same dir.
	scoreLines = open(sys.argv[2+i] + ".scores", "r").readlines()
	scoreLines = [map(float, x.strip().split("\t")) for x in scoreLines if len(x) != 0]
	
	rankedSystemsScores.append(scoreLines)
	rankedSystems.append(lines)

reader = TgtReader(sys.argv[1])
records = reader.GetRecords()
numRecords = len(records)
K = 10

systemsBleu4 = []
for i in range(numSystems):
	systemsBleu4.append(Bleu4())

trialsResults = numpy.zeros((numSystems))
for recordIndex, record in enumerate(records):
	#### For each ref compute the N*(N-1) blue
	refList = collections.OrderedDict()
	for rtext in record.rtext:
		refList[rtext] = 1
	
	for system in range(numSystems):
		systemsBleu4[system].UpdateMultiRefStats(list(refList), rankedSystems[system][recordIndex], rankedSystemsScores[system][recordIndex])

for system in range(numSystems):
	b4 = systemsBleu4[system].GetB4()
	trialsResults[system] = b4

print "Results ", numpy.sum(trialsResults, axis=0)