# Given a tgt file , compute some statistics
# on the length of the generated hypothesis
#
# @author Alessandro Sordoni

import sys
import tgt_reader
import bleu4
import numpy

if len(sys.argv) < 1:
	print "USAGE: TGT"
	sys.exit(-1)

### Load Tgt Records
tgt = tgt_reader.TgtReader(sys.argv[1])
records = tgt.GetRecords()

lengths = []
for record in records:
	for r in record.rlist:
		lengths.append(len(r.rtext.split(" ")))

lenArray = numpy.array(lengths)

mean = numpy.mean(lenArray)
std = numpy.std(lenArray)

print "Mean = ", str(mean), " Std = " , str(std)