@echo off

::: Download and install CUDA 6.0: https://developer.nvidia.com/cuda-toolkit
set CUDA="C:\Program Files\NVIDIA GPU Computing Toolkit\CUDA\v6.0"

::: Download "Intel Composer XE 2013 SP1 for Windows": https://software.intel.com/en-us/articles/redistributable-libraries-for-intel-c-and-visual-fortran-composer-xe-2013-for-windows
set MKL="C:\Program Files (x86)\Intel\Composer XE 2013 SP1\redist\intel64\mkl"

::: Download and install openblas: http://www.openblas.net/
set OPENBLAS="C:\Downloads\openblas-win64-int64"
:::set OPENBLAS="C:\Downloads\openblas-win64-int64-downloaded"

mkdir CpuNnet\ExtLib
mkdir CpuNnet\ExtLib\include
mkdir CpuNnet\ExtLib\lib
mkdir CpuNnet\ExtLib\lib\ut

mkdir CudaNnet\ExtLib
mkdir CudaNnet\ExtLib\include
mkdir CudaNnet\ExtLib\lib
mkdir CudaNnet\ExtLib\lib\ut

copy %OPENBLAS%\include\cblas.h CpuNnet\ExtLib\include\cblas.h
copy %OPENBLAS%\include\cblas.h CudaNnet\ExtLib\include\cblas.h

copy %OPENBLAS%\include\f77blas.h CpuNnet\ExtLib\include\f77blas.h
copy %OPENBLAS%\include\f77blas.h CudaNnet\ExtLib\include\f77blas.h

copy %OPENBLAS%\include\lapacke.h CpuNnet\ExtLib\include\lapacke.h
copy %OPENBLAS%\include\lapacke.h CudaNnet\ExtLib\include\lapacke.h

copy %OPENBLAS%\include\lapacke_config.h CpuNnet\ExtLib\include\lapacke_config.h
copy %OPENBLAS%\include\lapacke_config.h CudaNnet\ExtLib\include\lapacke_config.h

copy %OPENBLAS%\include\lapacke_mangling.h CpuNnet\ExtLib\include\lapacke_mangling.h
copy %OPENBLAS%\include\lapacke_mangling.h CudaNnet\ExtLib\include\lapacke_mangling.h

copy %OPENBLAS%\include\lapacke_utils.h CpuNnet\ExtLib\include\lapacke_utils.h
copy %OPENBLAS%\include\lapacke_utils.h CudaNnet\ExtLib\include\lapacke_utils.h

copy %OPENBLAS%\include\openblas_config.h CpuNnet\ExtLib\include\openblas_config.h
copy %OPENBLAS%\include\openblas_config.h CudaNnet\ExtLib\include\openblas_config.h

:: rename as needed: libopenblasp-r0.2.9.a -> libopenblas.a
copy %OPENBLAS%\lib\libopenblasp-r0.2.9.a CpuNnet\ExtLib\lib\libopenblas.a
copy %OPENBLAS%\lib\libopenblasp-r0.2.9.a CudaNnet\ExtLib\lib\libopenblas.a

copy %OPENBLAS%\lib\libopenblas.lib CpuNnet\ExtLib\lib\ut\libopenblas.lib
copy %OPENBLAS%\lib\libopenblas.lib CudaNnet\ExtLib\lib\ut\libopenblas.lib

copy %OPENBLAS%\lib\libopenblasp-r0.2.9.a CpuNnet\ExtLib\lib\libopenblasp-r0.2.9.a
copy %OPENBLAS%\lib\libopenblasp-r0.2.9.a CudaNnet\ExtLib\lib\libopenblasp-r0.2.9.a

copy %OPENBLAS%\bin\libopenblas.dll CpuNnet\ExtLib\lib\ut\libopenblas.dll
copy %OPENBLAS%\bin\libopenblas.dll CudaNnet\ExtLib\lib\ut\libopenblas.dll

copy %OPENBLAS%\bin\libgfortran-3.dll CpuNnet\ExtLib\lib\ut\libgfortran-3.dll
copy %OPENBLAS%\bin\libgfortran-3.dll CudaNnet\ExtLib\lib\ut\libgfortran-3.dll

copy %OPENBLAS%\bin\libgcc_s_seh-1.dll CpuNnet\ExtLib\lib\libgcc_s_seh-1.dll
copy %OPENBLAS%\bin\libgcc_s_seh-1.dll CudaNnet\ExtLib\lib\libgcc_s_seh-1.dll

copy %OPENBLAS%\bin\libgfortran-3.dll CpuNnet\ExtLib\lib\libgfortran-3.dll
copy %OPENBLAS%\bin\libgfortran-3.dll CudaNnet\ExtLib\lib\libgfortran-3.dll

copy %OPENBLAS%\bin\libgcc_s_seh-1.dll CpuNnet\ExtLib\lib\ut\libgcc_s_seh-1.dll
copy %OPENBLAS%\bin\libgcc_s_seh-1.dll CudaNnet\ExtLib\lib\ut\libgcc_s_seh-1.dll

copy %OPENBLAS%\bin\libquadmath-0.dll CpuNnet\ExtLib\lib\libquadmath-0.dll
copy %OPENBLAS%\bin\libquadmath-0.dll CpuNnet\ExtLib\lib\ut\libquadmath-0.dll
copy %OPENBLAS%\bin\libquadmath-0.dll CudaNnet\ExtLib\lib\libquadmath-0.dll

copy %CUDA%\bin\cublas64_60.dll CudaNnet\ExtLib\lib\ut\cublas64_60.dll
copy %CUDA%\bin\cudart64_60.dll CudaNnet\ExtLib\lib\ut\cudart64_60.dll
copy %CUDA%\bin\curand64_60.dll CudaNnet\ExtLib\lib\ut\curand64_60.dll
copy %CUDA%\bin\cusparse64_60.dll CudaNnet\ExtLib\lib\ut\cusparse64_60.dll

copy %MKL%\mkl_avx.dll CpuNnet\ExtLib\lib\ut\mkl_avx.dll
copy %MKL%\mkl_avx2.dll CpuNnet\ExtLib\lib\ut\mkl_avx2.dll
copy %MKL%\mkl_core.dll CpuNnet\ExtLib\lib\ut\mkl_core.dll
copy %MKL%\mkl_def.dll CpuNnet\ExtLib\lib\ut\mkl_def.dll
copy %MKL%\mkl_intel_thread.dll CpuNnet\ExtLib\lib\ut\mkl_intel_thread.dll
copy %MKL%\mkl_sequential.dll CpuNnet\ExtLib\lib\ut\mkl_sequential.dll

::CpuNnet\ExtLib\lib\ut\libopenblas_nehalemp-r0.2.9.a
::CudaNnet\ExtLib\lib\ut\libopenblas_nehalemp-r0.2.9.a

::CpuNnet\ExtLib\lib\backup_lib\libopenblas.dll
::CudaNnet\ExtLib\lib\backup_lib\libopenblas.dll

::CpuNnet\ExtLib\lib\backup_lib\libopenblas.lib
::CudaNnet\ExtLib\lib\backup_lib\libopenblas.lib

